.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data
Initial dd "RAND"

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push 100
				call Axrand
		counter_end
		print str$(eax), 9, "cycles for Axrand", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				push 100
				call Axrand2
		counter_end
		print str$(eax), 9, "cycles for Axrand2", 13, 10
		print chr$(13, 10)
	ENDM
	CodeSize Axrand
	CodeSize Axrand2
	inkey chr$(13, 10, "--- ok ---", 13)
	exit
option prologue:none
option epilogue:none	
Axrand_s:
Axrand proc STDCALL dwRange:DWORD
		xor edx, edx
		mov eax, Initial
		mov ecx, eax
		div dword ptr [esp+4]
		push edx
		mov eax, ecx
		xor eax, dword ptr [esp+4]  ; just one more seed
		imul eax, 12347
		add eax, 17
		bswap eax
		mov Initial, eax
		pop eax
		ret 4
Axrand endp
Axrand_endp:

Axrand2_s:
Axrand2 proc STDCALL dwRange:DWORD
		xor edx, edx
		mov eax, Initial
		push eax
		div dword ptr [esp+8]
		pop eax
		push edx
		xor eax, dword ptr [esp+4]  ; just one more seed
		imul eax, 12347
		add eax, 17
		bswap eax
		mov Initial, eax
		pop eax
		ret 4
Axrand2 endp
Axrand2_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]